diff --git a/mod/adobeconnect/joinrecording.php b/mod/adobeconnect/joinrecording.php
index 9e3654a..15de308 100644
--- a/mod/adobeconnect/joinrecording.php
+++ b/mod/adobeconnect/joinrecording.php
@@ -14,8 +14,9 @@ require_once(dirname(__FILE__).'/locallib.php');
 require_once(dirname(__FILE__).'/connect_class.php');
 require_once(dirname(__FILE__).'/connect_class_dom.php');
 
-$id         = required_param('id', PARAM_INT);
-$groupid    = required_param('groupid', PARAM_INT);
+$id          = required_param('id', PARAM_INT);
+$groupid     = required_param('groupid', PARAM_INT);
+$recordingid = required_param('recording', PARAM_INT);    
 
 // Do the usual Moodle setup
 if (! $cm = get_coursemodule_from_id('adobeconnect', $id)) {
@@ -67,27 +68,38 @@ $meetscoid = get_record_sql($sql);
 
 // Get the Meeting recording details
 $aconnect   = aconnect_login();
-$recording  = array();
+$recordings = array();
 $fldid      = aconnect_get_folder($aconnect, 'content');
 
 $data = aconnect_get_recordings($aconnect, $fldid, $meetscoid->meetingscoid);
 
 if (!empty($data)) {
-    $recording = $data;
+    $recordings = $data;
 }
 
 // If at first you don't succeed ...
 $data2 = aconnect_get_recordings($aconnect, $meetscoid->meetingscoid, $meetscoid->meetingscoid);
 
 if (!empty($data2)) {
-     $recording = $data2;
+     $recordings = $data2;
 }
 
 aconnect_logout($aconnect);
 
-if (empty($recording) and confirm_sesskey()) {
-    notify(get_string('errormeeting', 'adobeconnect'));
-    die();
+if ((!isset($recordings[$recordingid]) || empty($recordings[$recordingid])) && confirm_sesskey()) {
+    /// Print the page header
+    $stradobeconnects = get_string('modulenameplural', 'adobeconnect');
+    $stradobeconnect  = get_string('modulename', 'adobeconnect');
+
+    $navlinks = array();
+    $navlinks[] = array('name' => $stradobeconnects, 'link' => "index.php?id=$course->id", 'type' => 'activity');
+    $navlinks[] = array('name' => format_string($adobeconnect->name), 'link' => '', 'type' => 'activityinstance');
+
+    $navigation = build_navigation($navlinks);
+
+    print_header_simple(format_string($adobeconnect->name), '', $navigation, '', '', true,
+                  update_module_button($cm->id, $course->id, $stradobeconnect), navmenu($course, $cm));
+    notice(get_string('errorrecording', 'adobeconnect'));
 }
 
 add_to_log($course->id, 'adobeconnect', 'view',
@@ -102,6 +114,6 @@ if (!empty($CFG->adobeconnect_port) and (80 != $CFG->adobeconnect_port)) {
 
 
 redirect($protocol . $CFG->adobeconnect_meethost . $port
-                     . $recording->url . '?session=' . $adobesession);
+                     . $recordings[$recordingid]->url . '?session=' . $adobesession);
 
 ?>
\ No newline at end of file
diff --git a/mod/adobeconnect/view.php b/mod/adobeconnect/view.php
index 4b5d4bb..283063b 100644
--- a/mod/adobeconnect/view.php
+++ b/mod/adobeconnect/view.php
@@ -106,7 +106,7 @@ $sql = "SELECT meetingscoid FROM {$CFG->prefix}adobeconnect_meeting_groups amg W
 
 
 $meetscoids = get_records_sql($sql);
-$recording = array();
+$recordings = array();
 
 if (!empty($meetscoids)) {
     $recscoids = array();
@@ -145,14 +145,23 @@ if (!empty($meetscoids)) {
         // May need this later on
         $data = aconnect_get_recordings($aconnect, $fldid, $scoid->meetingscoid);
 
+        //Get group id for recording
+        if (0 !== $cm->groupmode) {
+            $rgroupid = get_records('adobeconnect_meeting_groups', 'meetingscoid', $scoid->meetingscoid, NULL, 'groupid', 0, 1);
+            $rgroupid = current(array_keys($rgroupid));
+        }
+        if (empty($rgroupid)) {
+            $rgroupid = 0;
+        }
+
         if (!empty($data)) {
-            $recording[] = $data;
+            $recordings[$rgroupid] = $data;
         }
 
         $data2 = aconnect_get_recordings($aconnect, $scoid->meetingscoid, $scoid->meetingscoid);
 
         if (!empty($data2)) {
-             $recording[] = $data2;
+             $recordings[$rgroupid] = $data2;
         }
 //        print_object(aconnect_get_recordings($aconnect, $fldid, $scoid->meetingscoid));
     }
@@ -161,9 +170,9 @@ if (!empty($meetscoids)) {
     // recording settings on ACP server change between publishing the recording links in meeting folders and
     // not publishing the recording links in meeting folders
     $names = array();
-    foreach ($recording as $key => $recordingarray) {
+    foreach ($recordings as $rgroupid => $recordingarray) {
 
-        foreach ($recordingarray as $key2 => $record) {
+        foreach ($recordingarray as $recording_scoid => $record) {
 
 
             if (!empty($names)) {
@@ -173,7 +182,7 @@ if (!empty($meetscoids)) {
                     $names[] = $record->name;
                 } else {
 
-                    unset($recording[$key][$key2]);
+                    unset($recordings[$rgroupid][$recording_scoid]);
                 }
             } else {
 
@@ -453,29 +462,19 @@ if (!$adobeconnect->meetingpublic) {
     $showrecordings = true;
 }
 
-$recordings = $recording;
-
-if ($showrecordings and !empty($recordings)) {
+if ($showrecordings && isset($recordings) && isset($recordings[$groupid]) && !empty($recordings[$groupid])) {
 
     echo '<div id="aconfldset2" class="aconfldset">'."\n";
     echo '<fieldset>'."\n";
     echo '<legend>'.get_string('recordinghdr', 'adobeconnect').'</legend>'."\n";
 
     echo '<div class="aconrecording">'."\n";
-    foreach ($recordings as $key => $recordinggrp) {
-
-        if (!empty($recordinggrp)) {
-
-            foreach($recordinggrp as $recording_scoid => $recording) {
-
-                echo '<div class="aconrecordingrow">'."\n";
-                echo '<a href="joinrecording.php?id=' . $id. '&recording='. $recording_scoid .
-                     '&groupid=' . $groupid . '&sesskey=' . $USER->sesskey .
-                     '" target="_blank">'. format_string($recording->name) .'</a><br />';
-                echo '</div>'."\n";
-
-            }
-        }
+    foreach ($recordings[$groupid] as $recording_scoid => $recording) {
+        echo '<div class="aconrecordingrow">'."\n";
+        echo '<a href="joinrecording.php?id=' . $id. '&recording='. $recording_scoid .
+             '&groupid=' . $groupid . '&sesskey=' . $USER->sesskey .
+             '" target="_blank">'. format_string($recording->name) .'</a><br />';
+        echo '</div>'."\n";
     }
     echo '</div>'."\n";
 